/*************************************************************
 * This script is Copyright and must not be distributed
 *************************************************************/

// the time before the first message is posted
// also this is the time after user posts the message
// and before the "Agent is Typing" appears
var TimeInit = 1000;

// this is the time before agent begin typing the next
// post in automatic welcome mode.
var TimeBeforeNewPost = 3000;

// time which agent is "typing" the message
var TimeDelay = 2000;


//-------------------------------------------------------------------------------
//-------------------------------------------------------------------------------

var oDiscusson = document.getElementById("commentdiv");
var oUserMessages = document.getElementById("typediv");
var oAgentTyping = document.getElementById("divAgentIsTyping");
var oBottomLine1 = document.getElementById("divBottomLine1");
var oBottomLine2 = document.getElementById("divBottomLine2");
var tAgent = null;
var tPost = null;
var bConversationStarted = false;
var iPrevMessageId = -1;
var iCurrentWelcomeMessage = -1;

oBottomLine1.innerHTML = tBottomLine1;
oBottomLine2.innerHTML = tBottomLine2;

function GetRandomString(source)
{
	var iNewMessageId = Math.floor(Math.random()*source.length);
	if ((iPrevMessageId == iNewMessageId) && (source.length>1))
		return GetRandomString(source);
	iPrevMessageId = iNewMessageId;
	return source[iNewMessageId];
}

var LastUserMessage = '';

function GetResponseString ()
{
	var msg = LastUserMessage.toLowerCase();
	for (var c = 1; c < MessagesDiscussion.length; c ++)
	{
		var smsg = MessagesDiscussion[c];
		var p = smsg.search (':');
		if (p == -1)  continue;
		smsg = smsg.substr (0, p);
		smsg = smsg.toLowerCase();
		if (smsg.search (',') != -1)
		{
			smsgset = smsg.split (',');
			for (var i = 0; i < smsgset.length; i ++)
			{
				if (msg.search (smsgset[i]) != -1) return MessagesDiscussion[c].substr(p + 1);
			}
		}
		else
		{
			if (msg.search (smsg) != -1) return MessagesDiscussion[c].substr(p + 1);
		}
	}
	return MessagesDiscussion [0];
}

function onUserMessage()
{
	if (oUserMessages.value!='')
	{

		setAgentTypingOff();

		clearTimeout(tAgent);
		clearTimeout(tPost);

		tAgent = setTimeout ( "setAgentTypingOn()", TimeInit );
		tPost = setTimeout ( "postMessage('discussion')", TimeInit + TimeDelay);

		if (oDiscusson.innerHTML!='')
			oDiscusson.innerHTML = oDiscusson.innerHTML + '<br><br>';

		LastUserMessage = oUserMessages.value;
		oDiscusson.innerHTML = oDiscusson.innerHTML + '<span class="messageUser"><b>You:</b> ' + oUserMessages.value + '</span>';
		oUserMessages.value = '';
		oDiscusson.scrollTop = oDiscusson.scrollHeight;
	}
}

function GetNextWelcomeMessage()
{
	if (iCurrentWelcomeMessage < MessagesWelcome.length-1)
	{
		iCurrentWelcomeMessage++;
		return MessagesWelcome[iCurrentWelcomeMessage];
	}
	return '';
}

var FirstTime = 1;

function postMessage(sMessageType)
{
	if (sMessageType == 'discussion')
	{
		var sMessage = GetResponseString ();
		if (sMessage.substr (0, 1) == ' ')  sMessage = sMessage.substr (1);
		sMessage = sMessage.replace ("%%link%%", linktext1);
		sMessage = sMessage.replace ("%%link1%%", linktext1);
		sMessage = sMessage.replace ("%%link2%%", linktext2);
		sMessage = sMessage.replace ("%%link3%%", linktext3);
		sMessage = sMessage.replace ("%%link4%%", linktext4);
	}
	else
	{
		//var sMessage = GetRandomString(MessagesWelcome);
		var sMessage = GetNextWelcomeMessage();
		sMessage = sMessage.replace ("%%link%%", linktext1);
		sMessage = sMessage.replace ("%%link1%%", linktext1);
		sMessage = sMessage.replace ("%%link2%%", linktext2);
		sMessage = sMessage.replace ("%%link3%%", linktext3);
		sMessage = sMessage.replace ("%%link4%%", linktext4);
		if (!bConversationStarted  &&  sMessage!=''  &&  iCurrentWelcomeMessage < MessagesWelcome.length-1)
		{
			tAgent = setTimeout ( "setAgentTypingOn()", TimeBeforeNewPost);
			tPost = setTimeout ( "postMessage('" + sMessageType + "')", TimeBeforeNewPost + TimeDelay);
		}
	}

	if (sMessage!='')
	{
		if (! FirstTime)
			oDiscusson.innerHTML = oDiscusson.innerHTML + '<br><br>';
		FirstTime = 0;
		oDiscusson.innerHTML = oDiscusson.innerHTML + '<span class="messageAgent"><b>' + AgentName + ':</b> ' + sMessage + '</span>';
	}

	setAgentTypingOff();

	oDiscusson.scrollTop = oDiscusson.scrollHeight;
}

function setAgentTypingOn()
{
	oAgentTyping.innerHTML = AgentName + ' Is Typing...';
}

function setAgentTypingOff()
{
	oAgentTyping.innerHTML = '&nbsp;';
}


window.onload = function()
{
	setAgentTypingOff();
	tAgent = setTimeout ( "setAgentTypingOn()", 0);
	tPost = setTimeout ( "postMessage('welcome')", TimeInit);
}